SystemOrganization addCategory: #'Egg-Core'!
SystemOrganization addCategory: #'Egg-NBEina'!
SystemOrganization addCategory: #'Egg-NBEvas'!
SystemOrganization addCategory: #'Egg-Evas'!
SystemOrganization addCategory: #'Egg-SDL'!
SystemOrganization addCategory: #'Egg-Tests-Evas'!

NBExternalStructure variableByteSubclass: #NBEvasEngineInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasEngineInfo commentStamp: '<historical>' prior: 0!
I am abstract evas engine information structure.
My instance is argument for evas_engine_info_set and value of evas_engine_info_get
!

!NBEvasEngineInfo class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 2/12/2012 02:57'!
renderMethod
	self subclassResponsibility.! !

NBEvasEngineInfo variableByteSubclass: #NBEvasEngineInfoSDL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasEngineInfoSDL commentStamp: '<historical>' prior: 0!
I am evas SDL engine information structure.!

!NBEvasEngineInfoSDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 03:51'!
fieldsDesc
	^ #(
		int magic;
		int rotation;
		int fullscreen;
		int noframe;
		)! !

!NBEvasEngineInfoSDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 03:51'!
renderMethod
	^'gl_sdl'! !

NBEvasEngineInfo variableByteSubclass: #NBEvasEngineInfoX11
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasEngineInfoX11 commentStamp: '<historical>' prior: 0!
I am evas software X11 engine information structure.
!

!NBEvasEngineInfoX11 class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:52'!
fieldsDesc
	^ #(
		int magic;
		)! !

!NBEvasEngineInfoX11 class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:49'!
renderMethod
	^'software_x11'! !

!NBEvasEngineInfoX11 methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:53'!
fullscreen
	^false! !

!NBEvasEngineInfoX11 methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:53'!
fullscreen: aValue
	"not supported for this engine"! !

Link subclass: #EvasObject
	instanceVariableNames: 'x y width height color visible handler group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

EvasObject subclass: #EvasImage
	instanceVariableNames: 'sourceFile key imageWidth imageHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 4/8/2012 00:11'!
getNBEvasObjectFor: aNBEvas

	^ aNBEvas addImage.! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 01:07'!
imageHeight
	^ imageHeight! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 4/28/2012 20:35'!
imageHeight: anObject
	imageHeight := anObject.
	self updateImageSize.! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 01:07'!
imageWidth
	^ imageWidth! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 4/28/2012 20:35'!
imageWidth: anObject
	imageWidth := anObject.
	self updateImageSize.! !

!EvasImage methodsFor: 'initialize-release' stamp: 'EgorScorik 1/5/2012 01:21'!
initialize 

	super initialize.
	imageWidth := 0.
	imageHeight := 0.
	sourceFile := ''.
	key := ''.
! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:34'!
key
	^ key! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:48'!
key: anObject
	key := anObject.
	self updateFile.! !

!EvasImage methodsFor: 'errors' stamp: 'EgorScorik 1/5/2012 00:31'!
loadError
	^ self handler loadErrorFromCode: self handler loadErrorCode! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:34'!
sourceFile
	^ sourceFile! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:47'!
sourceFile: anObject
	sourceFile := anObject.
	self updateFile! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	super update.
	self updateFile.
	! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 01:36'!
updateFile
	handler
		ifNotNil: [ 
			handler setFile: sourceFile key: key.
			self updateImageSize ]! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/5/2012 21:35'!
updateImageSize
	handler
		ifNotNil: [ 
			handler getImageInfo.
			imageWidth := handler imageWidth.
			imageHeight := handler imageHeight.
			self width: imageWidth.
			self height: imageHeight ]! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/5/2012 00:09'!
updateSize
	(width = 0 or: height = 0)
		ifFalse: [ handler ifNotNil: [ handler width: width height: height ] ]! !

EvasObject subclass: #EvasLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasLine methodsFor: 'update' stamp: 'EgorScorik 4/8/2012 00:12'!
getNBEvasObjectFor: aNBEvas

	^ aNBEvas addLine! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
color
	^ color! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:28'!
color: anObject
	color := anObject.
	self updateColor.! !

!EvasObject methodsFor: 'initialize-release' stamp: 'EgorScorik 4/8/2012 00:53'!
free

	handler ifNotNil: [ handler free ].! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 4/8/2012 00:12'!
getNBEvasObjectFor: aNBEvas

	self subclassResponsibility.! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 00:34'!
group
	^ group! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 00:34'!
group: anObject
	group := anObject! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:35'!
handler
	^ handler! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:35'!
handler: nbEvasObject
	^ handler := nbEvasObject! !

!EvasObject methodsFor: 'comparing' stamp: 'EgorScorik 5/7/2012 00:46'!
hash
	^ self handler hash! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
height
	^ height! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:32'!
height: anObject
	height := anObject.
	self updateSize! !

!EvasObject methodsFor: 'initialize-release' stamp: 'EgorScorik 1/5/2012 00:05'!
initialize 

	x := 0.
	y := 0.
	width := 0.
	height := 0.
	visible := true.! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	self
		updateXY;
		updateSize;
		updateColor;
		updateVisibility! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/5/2012 00:11'!
updateColor
	(handler isNil or: color isNil) ifFalse: [
			handler
				colorR: (color red * 255) asInteger
				G: (color green * 255) asInteger
				B: (color blue * 255) asInteger
				A: (color alpha * 255) asInteger ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 4/8/2012 00:46'!
updateHandler: anEvas
	anEvas ifNil: [ ^self ].
	self handler: (self getNBEvasObjectFor: anEvas handler).
	self update! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/4/2012 22:29'!
updateSize
	handler ifNotNil: [ handler width: width height: height ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/4/2012 22:06'!
updateVisibility
	handler
		ifNotNil: [ 
			self visible
				ifTrue: [ handler show ]
				ifFalse: [ handler hide ] ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/4/2012 22:29'!
updateXY
	handler ifNotNil: [ handler moveToX: x Y: y ]! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
visible
	^ visible! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:07'!
visible: anObject
	visible := anObject.
	self updateVisibility! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
width
	^ width! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:31'!
width: anObject
	width := anObject.
	self updateSize! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
x
	^ x! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:31'!
x: anObject
	x := anObject.
	self updateXY! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
y
	^ y! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:31'!
y: anObject
	y := anObject.
	self updateXY! !

EvasObject subclass: #EvasPolygon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasPolygon methodsFor: 'update' stamp: 'EgorScorik 4/8/2012 00:12'!
getNBEvasObjectFor: aNBEvas

	^ aNBEvas addPolygon! !

EvasObject subclass: #EvasRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasRectangle methodsFor: 'update' stamp: 'EgorScorik 4/8/2012 00:12'!
getNBEvasObjectFor: aNBEvas

	^ aNBEvas addRectangle.! !

!EvasRectangle methodsFor: 'update' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	super update.
	! !

EvasObject subclass: #EvasText
	instanceVariableNames: 'fontName text fontSize fontSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:32'!
font
	^ fontName! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:32'!
font: anObject
	fontName := anObject.
	self updateFont.! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 03:11'!
font: anObject size: size
	fontName := anObject.
	fontSize := size.
	self updateFont! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:06'!
fontSize
	^ fontSize! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:25'!
fontSize: anObject
	fontSize := anObject.
	self updateFont.
	! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:31'!
fontSource
	^ fontSource! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:31'!
fontSource: anObject
	fontSource := anObject.
	self updateFontSource.! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 4/8/2012 00:12'!
getNBEvasObjectFor: aNBEvas

	^ aNBEvas addText! !

!EvasText methodsFor: 'initialize-release' stamp: 'EgorScorik 1/6/2012 02:05'!
initialize 

	super initialize.
	fontName := 'Arial'.
	text := ''.
	fontSize := 12.
! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:03'!
text
	^ text! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:12'!
text: anObject
	text := anObject.
	self updateText! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	super update.
	self updateFont.
	self updateFontSource.
	self updateText.! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 02:14'!
updateFont
	handler ifNotNil: [ handler setFont: fontName size: fontSize. ]! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 02:31'!
updateFontSource
	handler ifNotNil: [ fontSource ifNotNil: [ handler setFontSource: fontSource ] ]! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 02:12'!
updateText
	handler ifNotNil: [ handler setText: text ]! !

EvasObject subclass: #EvasTextblock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasTextblock methodsFor: 'update' stamp: 'EgorScorik 4/8/2012 00:13'!
getNBEvasObjectFor: aNBEvas

	^ aNBEvas addTextblock! !

SharedPool subclass: #SDLConstants
	instanceVariableNames: ''
	classVariableNames: 'AnnouncementClasses EventClasses'
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLConstants commentStamp: '<historical>' prior: 0!
C-side stuff for SDL!

!SDLConstants class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/25/2012 02:29'!
eventClasses

"/** Event enumerations */
typedef enum {
       SDL_NOEVENT = 0,			/**< Unused (do not remove) */
       SDL_ACTIVEEVENT,			/**< Application loses/gains visibility */
       SDL_KEYDOWN,			/**< Keys pressed */
       SDL_KEYUP,			/**< Keys released */
       SDL_MOUSEMOTION,			/**< Mouse moved */
       SDL_MOUSEBUTTONDOWN,		/**< Mouse button pressed */
       SDL_MOUSEBUTTONUP,		/**< Mouse button released */
       SDL_JOYAXISMOTION,		/**< Joystick axis motion */
       SDL_JOYBALLMOTION,		/**< Joystick trackball motion */
       SDL_JOYHATMOTION,		/**< Joystick hat position change */
       SDL_JOYBUTTONDOWN,		/**< Joystick button pressed */
       SDL_JOYBUTTONUP,			/**< Joystick button released */
       SDL_QUIT,			/**< User-requested quit */
       SDL_SYSWMEVENT,			/**< System specific event */
       SDL_EVENT_RESERVEDA,		/**< Reserved for future use.. */
       SDL_EVENT_RESERVEDB,		/**< Reserved for future use.. */
       SDL_VIDEORESIZE,			/**< User resized video mode */
       SDL_VIDEOEXPOSE,			/**< Screen needs to be redrawn */
       SDL_EVENT_RESERVED2,		/**< Reserved for future use.. */
       SDL_EVENT_RESERVED3,		/**< Reserved for future use.. */
       SDL_EVENT_RESERVED4,		/**< Reserved for future use.. */
       SDL_EVENT_RESERVED5,		/**< Reserved for future use.. */
       SDL_EVENT_RESERVED6,		/**< Reserved for future use.. */
       SDL_EVENT_RESERVED7,		/**< Reserved for future use.. */
       /** Events SDL_USEREVENT through SDL_MAXEVENTS-1 are for your use */
       SDL_USEREVENT = 24,
       /** This last event is only for bounding internal arrays
	*  It is the number of bits in the event mask datatype -- Uint32
        */
       SDL_NUMEVENTS = 32
} SDL_EventType;"

	EventClasses := Dictionary new.
	AnnouncementClasses := Dictionary new.
	
	AnnouncementClasses at: 1 put: Activate.
	EventClasses at: 1 put: SDLActiveEvent.
	AnnouncementClasses at: 2 put: KeyDown.
	EventClasses at: 2 put: SDLKeyboardEvent.
	AnnouncementClasses at: 3 put: KeyUp.
	EventClasses at: 3 put: SDLKeyboardEvent.
	AnnouncementClasses at: 4 put: MouseMove.
	EventClasses at: 4 put: SDLMouseMotionEvent .
	AnnouncementClasses at: 5 put: MouseDown.
	EventClasses at: 5 put: SDLMouseButtonEvent .
	AnnouncementClasses at: 6 put: MouseUp.
	EventClasses at: 6 put: SDLMouseButtonEvent.
	AnnouncementClasses at: 12 put: Quit.
	EventClasses at: 12 put: SDLEvent.! !

!SDLConstants class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/19/2012 02:13'!
initialize

	self eventClasses.! !

NBExternalStructure variableByteSubclass: #SDLEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'SDLConstants'
	category: 'Egg-SDL'!

!SDLEvent commentStamp: '<historical>' prior: 0!
SDLEvent on C-side is union. I am structure who can contain any of SDL events.

typedef union{
  Uint8 type;
  SDL_ActiveEvent active;
  SDL_KeyboardEvent key;
  SDL_MouseMotionEvent motion;
  SDL_MouseButtonEvent button;
  SDL_JoyAxisEvent jaxis;
  SDL_JoyBallEvent jball;
  SDL_JoyHatEvent jhat;
  SDL_JoyButtonEvent jbutton;
  SDL_ResizeEvent resize;
  SDL_ExposeEvent expose;
  SDL_QuitEvent quit;
  SDL_UserEvent user;
  SDL_SywWMEvent syswm;
} SDL_Event;
!

SDLEvent variableByteSubclass: #SDLActiveEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLActiveEvent commentStamp: '<historical>' prior: 0!
Application visibility event structure

typedef struct SDL_ActiveEvent {
	Uint8 type;	/**< SDL_ACTIVEEVENT */
	Uint8 gain;	/**< Whether given states were gained or lost (1/0) */
	Uint8 state;	/**< A mask of the focus states */
} SDL_ActiveEvent;!

!SDLActiveEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 4/28/2012 18:32'!
fieldsDesc
	^ #(byte type;
		byte gain;
		byte state;
		)! !

!SDLEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/19/2012 02:52'!
announcementFrom: anEvent
	| annClass eventClass |
	annClass := AnnouncementClasses at: anEvent type ifAbsent: [^nil].
	eventClass := EventClasses at: anEvent type ifAbsent: [^nil].
	^annClass fromEvent: (eventClass fromPointer: anEvent)
! !

!SDLEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/1/2012 23:03'!
fieldsDesc

	^ #(byte type)! !

!SDLEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 4/28/2012 18:27'!
instanceSize
	"sizeof(SDL_Event)"
	^20! !

SDLEvent variableByteSubclass: #SDLKeyboardEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLKeyboardEvent commentStamp: '<historical>' prior: 0!
/** Keyboard event structure */

typedef struct SDL_KeyboardEvent {
	Uint8 type;	/**< SDL_KEYDOWN or SDL_KEYUP */
	Uint8 which;	/**< The keyboard device index */
	Uint8 state;	/**< SDL_PRESSED or SDL_RELEASED */
	SDL_keysym keysym;
} SDL_KeyboardEvent;

typedef struct SDL_keysym {
	Uint8 scancode;			/**< hardware specific scancode */
	SDLKey sym;			/**< SDL virtual keysym */
	SDLMod mod;			/**< current key modifiers */
	Uint16 unicode;			/**< translated character */
} SDL_keysym;
!

!SDLKeyboardEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 4/28/2012 18:32'!
fieldsDesc

	^ #(byte type;
		byte which;
		byte state;
		byte padding1;
		
		byte scancode;
		byte padding2;
		byte padding3;
		byte padding4;
		
		uint sym;
		uint mod;
		ushort unicode;
		)! !

SDLEvent variableByteSubclass: #SDLMouseButtonEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLMouseButtonEvent commentStamp: '<historical>' prior: 0!
/** Mouse button event structure */
typedef struct SDL_MouseButtonEvent {
	Uint8 type;	/**< SDL_MOUSEBUTTONDOWN or SDL_MOUSEBUTTONUP */
	Uint8 which;	/**< The mouse device index */
	Uint8 button;	/**< The mouse button index */
	Uint8 state;	/**< SDL_PRESSED or SDL_RELEASED */
	Uint16 x, y;	/**< The X/Y coordinates of the mouse at press time */
} SDL_MouseButtonEvent;!

!SDLMouseButtonEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 4/28/2012 18:35'!
fieldsDesc
	^ #(byte type;
		byte which;
		byte button;
		byte state;
		ushort x;
		ushort y;
		)! !

SDLEvent variableByteSubclass: #SDLMouseMotionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLMouseMotionEvent commentStamp: '<historical>' prior: 0!
/** Mouse motion event structure */
typedef struct SDL_MouseMotionEvent {
	Uint8 type;	/**< SDL_MOUSEMOTION */
	Uint8 which;	/**< The mouse device index */
	Uint8 state;	/**< The current button state */
	Uint16 x, y;	/**< The X/Y coordinates of the mouse */
	Sint16 xrel;	/**< The relative motion in the X direction */
	Sint16 yrel;	/**< The relative motion in the Y direction */
} SDL_MouseMotionEvent;
!

!SDLMouseMotionEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 4/28/2012 18:35'!
fieldsDesc
	^ #(byte type;
		byte which;
		byte state;
		byte padding;
		ushort x;
		ushort y;
		short xrel;
		short yrel;
		)! !

NBExternalObject subclass: #NBEinaIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEina'!

!NBEinaIterator class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 16:45'!
nbLibraryNameOrHandle
	^ '/usr/lib/libeina.so'! !

!NBEinaIterator methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 13:17'!
asArray
	| pointer array |
	array := OrderedCollection new.
	[ pointer := self next ] whileNotNil: [ array add: pointer ].
	^ array! !

!NBEinaIterator methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 12:27'!
asStringArray
	^self asArray collect: [:each | each readString. ]! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 12:19'!
free
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void eina_iterator_free (#NBEinaIterator self))! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:13'!
getNext: data
"
/**
 * @brief Return the value of the current element and go to the next one.
 *
 * @param iterator The iterator.
 * @param data The data of the element.
 * @return #EINA_TRUE on success, #EINA_FALSE otherwise.
 *
 * This function returns the value of the current element pointed by
 * @p iterator in @p data, then goes to the next element. If @p
 * iterator is @c NULL or if a problem occurred, #EINA_FALSE is
 * returned, otherwise #EINA_TRUE is returned.
 */
EAPI Eina_Bool eina_iterator_next(Eina_Iterator *iterator,
                                  void         **data) EINA_ARG_NONNULL(1, 2) EINA_WARN_UNUSED_RESULT;
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int eina_iterator_next (#NBEinaIterator self, NBExternalAddress* data))! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 12:15'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:11'!
next
	|result|
	result := NBExternalAddress new.
	
	^((self getNext: result) = 1) ifTrue: [result ] ifFalse: [nil].! !

NBExternalObject subclass: #NBEinaList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEina'!

!NBEinaList class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 16:45'!
nbLibraryNameOrHandle
	^ '/usr/lib/libeina.so'! !

!NBEinaList methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 12:33'!
asArray
	| iterator array |
	iterator := self iterator.
	array := iterator asArray.
	iterator free.
	^ array! !

!NBEinaList methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 12:34'!
asStringArray
	| iterator array |
	iterator := self iterator.
	array := iterator asStringArray.
	iterator free.
	^ array! !

!NBEinaList methodsFor: 'accessing' stamp: 'EgorScorik 5/7/2012 12:14'!
iterator
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEinaIterator eina_list_iterator_new (#NBEinaList self))! !

!NBEinaList methodsFor: 'nativeboost' stamp: 'EgorScorik 2/11/2012 20:24'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

NBExternalObject subclass: #NBEvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvas commentStamp: '<historical>' prior: 0!
I am native boost wrapper for libevas general functions on my class side and Evas (canvas instance) on my instance side.

http://docs.enlightenment.org/auto/evas/modules.html!

!NBEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 2/11/2012 22:52'!
init
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int evas_init ())! !

!NBEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 16:46'!
nbLibraryNameOrHandle
	^ '/usr/lib/libevas.so'! !

!NBEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 2/11/2012 22:19'!
new
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvas evas_new ())! !

!NBEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 2/11/2012 22:52'!
shutdown
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int evas_shutdown ())! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 4/28/2012 19:21'!
addImage
"
Evas_Object* evas_object_image_filled_add	(Evas * 	e)
Creates a new image object that automatically scales its bound image to the object's area, on both axis.

Parameters:
e	The given canvas.
Returns:
The created image object handle.
This is a helper function around evas_object_image_add() and evas_object_image_filled_set(). It has the same effect of applying those functions in sequence, which is a very common use case.
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasImage evas_object_image_filled_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 4/28/2012 19:27'!
addLine

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasLine evas_object_line_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/15/2012 03:20'!
addPolygon
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasPolygon evas_object_polygon_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/4/2012 23:44'!
addRectangle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasRectangle evas_object_rectangle_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/6/2012 01:46'!
addText
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasText evas_object_text_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/15/2012 03:13'!
addTextblock
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasTextblock evas_object_textblock_add (#NBEvas self))! !

!NBEvas methodsFor: 'initialize-release' stamp: 'EgorScorik 2/11/2012 21:02'!
free
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_free (#NBEvas self))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 2/11/2012 22:42'!
freeRenderMethodList: aList
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_render_method_list_free (#NBEinaList aList))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 4/28/2012 19:11'!
getEngineInfo
"Evas_Engine_Info* evas_engine_info_get	(const Evas *e)	
Retrieves the current render engine info struct from the given evas.

The returned structure is publicly modifiable. The contents are valid until either evas_engine_info_set or evas_render are called.

This structure does not need to be freed by the caller."
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void* evas_engine_info_get (NBEvas self))! !

!NBEvas methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 19:41'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEvas methodsFor: 'initialize-release' stamp: 'EgorScorik 2/11/2012 20:58'!
new
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEvas evas_new ())! !

!NBEvas methodsFor: 'viewpoint' stamp: 'EgorScorik 2/12/2012 01:15'!
outputWidth: w height: h
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_output_size_set (NBEvas self, int w, int h))! !

!NBEvas methodsFor: 'rendering' stamp: 'EgorScorik 2/12/2012 14:45'!
render
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_render (NBEvas self))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 2/11/2012 22:30'!
renderMethodList
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEinaList evas_render_method_list (#NBEvas self))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 2/12/2012 00:21'!
renderMethodLookup: aRenderName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int evas_render_method_lookup (String aRenderName))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 4/28/2012 19:09'!
setEngineInfo: info
"
Eina_Bool evas_engine_info_set (Evas * e, Evas_Engine_Info * info)
Applies the engine settings for the given evas from the given Evas_Engine_Info structure.

To get the Evas_Engine_Info structure to use, call evas_engine_info_get . Do not try to obtain a pointer to an Evas_Engine_Info structure in any other way.

You will need to call this function at least once before you can create objects on an evas or render that evas. Some engines allow their settings to be changed more than once.

Once called, the info pointer should be considered invalid."
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_engine_info_set (NBEvas self, void* info))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 2/12/2012 00:43'!
setOutputMethod: aMethodId
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_output_method_set (NBEvas self, int aMethodId))! !

!NBEvas methodsFor: 'finding' stamp: 'EgorScorik 4/29/2012 04:14'!
topAtX: x Y: y
"Evas_Object* evas_object_top_at_xy_get	(const Evas *e, Evas_Coord x, Evas_Coord y, Eina_Bool include_pass_events_objects, Eina_Bool include_hidden_objects )
Retrieve the Evas object stacked at the top of a given position in a canvas.

Parameters:
e	A handle to the canvas.
x	The horizontal coordinate of the position
y	The vertical coordinate of the position
include_pass_events_objects	Boolean flag to include or not objects which pass events in this calculation
include_hidden_objects	Boolean flag to include or not hidden objects in this calculation
Returns:
The Evas object that is over all other objects at the given position.
This function will traverse all the layers of the given canvas, from top to bottom, querying for objects with areas covering the given position. The user can remove from from the query objects which are hidden and/or which are set to pass events."
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEvasObject evas_object_top_at_xy_get (NBEvas self, int x, int y, 0, 0))! !

!NBEvas methodsFor: 'viewpoint' stamp: 'EgorScorik 2/12/2012 01:17'!
viewportX: x y: y width: w height: h
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_output_viewport_set (NBEvas self, int x, int y, int w, int h))! !

NBExternalObject subclass: #NBEvasObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasObject commentStamp: '<historical>' prior: 0!
I am abstract evas object.

http://docs.enlightenment.org/auto/evas/group__Evas__Object__Group.html!

NBEvasObject subclass: #NBEvasImage
	instanceVariableNames: 'imageWidth imageHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasImage commentStamp: '<historical>' prior: 0!
I am raster image.!

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 21:39'!
getImageInfo
	imageWidth := ByteArray new: 4.
	imageHeight := ByteArray new: 4.
	self getImageWidth: imageWidth height: imageHeight.
	imageWidth := imageWidth nbUlongAt: 1.
	imageHeight := imageHeight nbUlongAt: 1.! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 22:17'!
getImageWidth: width height: height
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( void evas_object_image_size_get (#NBEvasImage self, int* width, int* height))! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageHeight
	^ imageHeight! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageHeight: anObject
	imageHeight := anObject! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageWidth
	^ imageWidth! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageWidth: anObject
	imageWidth := anObject! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 00:27'!
loadErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(#int #evas_object_image_load_error_get #(#NBEvasImage #self))! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 00:28'!
loadErrorFromCode: code
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(#String #evas_load_error_str #(#int #code))! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 21:46'!
setFile: aFilename key: key
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_image_file_set (#NBEvasImage self, String aFilename, nil))! !

NBEvasObject subclass: #NBEvasLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasLine commentStamp: '<historical>' prior: 0!
I am line.!

!NBEvasObject class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 16:46'!
nbLibraryNameOrHandle
	^ '/usr/lib/libevas.so'! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
colorR: r G: g B: b A: a
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_color_set (#NBEvasObject self, int r, int g, int b, int a))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:43'!
free
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_del (#NBEvasObject self))! !

!NBEvasObject methodsFor: 'comparing' stamp: 'EgorScorik 5/7/2012 00:45'!
hash
	^self handle hash.! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
hide
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_hide (#NBEvasObject self))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
moveToX: x Y: y
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_move (#NBEvasObject self, int x, int y))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 19:45'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
show
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_show (#NBEvasObject self))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
width: w height: h
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_resize (#NBEvasObject self, int w, int h))! !

NBEvasObject subclass: #NBEvasPolygon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasPolygon commentStamp: '<historical>' prior: 0!
I am polygon.!

NBEvasObject subclass: #NBEvasRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasRectangle commentStamp: '<historical>' prior: 0!
I am rectangle.!

NBEvasObject subclass: #NBEvasText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasText commentStamp: '<historical>' prior: 0!
I am single line simple text.!

!NBEvasText methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/6/2012 01:59'!
setFont: aFontfamily size: size
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_text_font_set (NBEvasText self , String aFontfamily, int size))! !

!NBEvasText methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/6/2012 02:02'!
setFontSource: aFilename
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_text_font_source_set (NBEvasText self , String aFilename))! !

!NBEvasText methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/6/2012 01:58'!
setText: aString
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(#void #evas_object_text_text_set #(#NBEvasText self , String aString))! !

NBEvasObject subclass: #NBEvasTextblock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasTextblock commentStamp: '<historical>' prior: 0!
I am styled multiline text block.!

Announcement subclass: #SDLAnnouncement
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLAnnouncement commentStamp: '<historical>' prior: 0!
I am announcment for SDLEvent!

SDLAnnouncement subclass: #Activate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!Activate commentStamp: '<historical>' prior: 0!
I am raised when a window gain or lose focus

!

!Activate methodsFor: 'as yet unclassified' stamp: 'EgorScorik 4/28/2012 17:42'!
focusIn

	^ event gain = 1.! !

!Activate methodsFor: 'as yet unclassified' stamp: 'EgorScorik 4/28/2012 17:42'!
focusOut

	^ event gain = 0.! !

SDLAnnouncement subclass: #Quit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!Quit commentStamp: '<historical>' prior: 0!
I am raised when user close a window
!

!SDLAnnouncement class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/2/2012 00:45'!
fromEvent: anEvent
	| inst |
	inst := self new.
	inst event: anEvent.
	^ inst! !

!SDLAnnouncement methodsFor: 'accessing' stamp: 'EgorScorik 3/2/2012 00:45'!
event
	^ event! !

!SDLAnnouncement methodsFor: 'accessing' stamp: 'EgorScorik 3/2/2012 00:45'!
event: anObject
	event := anObject! !

SDLAnnouncement subclass: #SDLKeyboardAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLKeyboardAnnouncement commentStamp: '<historical>' prior: 0!
One of my subclasess raised when user do something with a keyboard.!

SDLKeyboardAnnouncement subclass: #KeyDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!KeyDown commentStamp: '<historical>' prior: 0!
I am raised when user press a key!

!KeyDown methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/19/2012 04:38'!
character
	"Unicode field filled only for key down event"
	^ Character value: self event unicode! !

SDLKeyboardAnnouncement subclass: #KeyUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!KeyUp commentStamp: '<historical>' prior: 0!
I am raised when user release a key!

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:01'!
ampersand

	^ self event sym = 38! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
asterisk

	^ self event sym = 42! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:06'!
at

	^ self event sym = 64! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
backSlash

	^ self event sym = 92! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
backquote

	^ self event sym = 96! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:08'!
backspace

	^ self event sym = 8! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:25'!
breakKey

	^ self event sym = 318! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:20'!
capsLock

	^(self event sym = 301) or: ((8192 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
caret

	^ self event sym = 94! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:08'!
clear

	^ self event sym = 12! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:05'!
colon

	^ self event sym = 58! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
comma

	^ self event sym = 44! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/20/2012 00:24'!
compose

	^ self event sym = 314! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:10'!
delete

	^ self event sym = 127! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/19/2012 23:58'!
dollar

	^ self event sym = 36! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/19/2012 23:57'!
doubleQuote

	^ self event sym = 34! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
down

	^ self event sym = 274! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
end

	^ self event sym = 279! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:06'!
equals

	^ self event sym = 61! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:09'!
escape

	^ self event sym = 27! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:26'!
euro

	^ self event sym = 321! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/19/2012 23:57'!
exclaim

	^ self event sym = 33! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f1

	^ self event sym = 282! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f10

	^ self event sym = 291! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f11

	^ self event sym = 292! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f12

	^ self event sym = 293! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f13

	^ self event sym = 294! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f14

	^ self event sym = 295! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f15

	^ self event sym = 296! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f2

	^ self event sym = 283! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f3

	^ self event sym = 284! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f4

	^ self event sym = 285! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f5

	^ self event sym = 286! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f6

	^ self event sym = 287! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f7

	^ self event sym = 288! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f8

	^ self event sym = 289! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f9

	^ self event sym = 290! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:06'!
greater

	^ self event sym = 62! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:25'!
help

	^ self event sym = 315! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
home

	^ self event sym = 278! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
insert

	^ self event sym = 277! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:54'!
key0

	^ self event sym = 48! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:52'!
key1

	^ self event sym = 49! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key2

	^ self event sym = 50! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key3

	^ self event sym = 51! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key4

	^ self event sym = 52! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key5

	^ self event sym = 53! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key6

	^ self event sym = 54! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key7

	^ self event sym = 55! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:54'!
key8

	^ self event sym = 56! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:54'!
key9

	^ self event sym = 57! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:44'!
keyA

	^ self event sym = 97! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:47'!
keyB

	^ self event sym = 98! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:47'!
keyD

	^ self event sym = 100! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:48'!
keyE

	^ self event sym = 101! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:48'!
keyF

	^ self event sym = 102! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:48'!
keyG

	^ self event sym = 103! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:48'!
keyH

	^ self event sym = 104! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyI

	^ self event sym = 105! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyJ

	^ self event sym = 106! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyK

	^ self event sym = 107! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyL

	^ self event sym = 108! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyM

	^ self event sym = 109! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyN

	^ self event sym = 110! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyO

	^ self event sym = 111! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyP

	^ self event sym = 112! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyQ

	^ self event sym = 113! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyR

	^ self event sym = 114! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyS

	^ self event sym = 115! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyT

	^ self event sym = 116! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyU

	^ self event sym = 117! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyV

	^ self event sym = 118! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyW

	^ self event sym = 119! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyX

	^ self event sym = 120! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyY

	^ self event sym = 121! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyZ

	^ self event sym = 122! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
left

	^ self event sym = 276! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:15'!
leftAlt

	^(self event sym = 308) or: ((256 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
leftBracket

	^ self event sym = 91! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:13'!
leftCtrl

	^ (self event sym = 306) or: ((64 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:16'!
leftMeta

	^(self event sym = 310) or: ((1024 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:03'!
leftParenthesis

	^ self event sym = 40! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:11'!
leftShift

	^ (self event sym = 304) or: ((1 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/20/2012 00:23'!
leftSuper

	^ self event sym = 311! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:05'!
less

	^ self event sym = 60! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:26'!
menu

	^ self event sym = 319! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
minus

	^ self event sym = 45! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:20'!
mode
	^(self event sym = 313) or: ((16384 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:18'!
numLock

	^(self event sym = 300) or: ((4096 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/19/2012 23:59'!
numberSign

	^ self event sym = 35! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:12'!
numpad0

	^ self event sym = 256! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad1

	^ self event sym = 257! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad2

	^ self event sym = 258! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad3

	^ self event sym = 259! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad4

	^ self event sym = 260! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad5

	^ self event sym = 261! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad6

	^ self event sym = 262! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad7

	^ self event sym = 263! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad8

	^ self event sym = 264! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad9

	^ self event sym = 265! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:14'!
numpadDivide

	^ self event sym = 267! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:15'!
numpadEnter

	^ self event sym = 271! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:15'!
numpadEquals

	^ self event sym = 272! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:15'!
numpadMinus

	^ self event sym = 269! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:14'!
numpadMultiply

	^ self event sym = 268! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:14'!
numpadPeriod

	^ self event sym = 266! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:15'!
numpadPlus

	^ self event sym = 270! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:12'!
pageDown

	^ self event sym = 281! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
pageUp

	^ self event sym = 280! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:09'!
pause

	^ self event sym = 19! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
period

	^ self event sym = 46! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
plus

	^ self event sym = 43! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:26'!
power

	^ self event sym = 320! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:25'!
print

	^ self event sym = 316! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:06'!
question

	^ self event sym = 63! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:01'!
quote

	^ self event sym = 39! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:09'!
return

	^ self event sym = 13! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
right

	^ self event sym = 275! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:16'!
rightAlt

	^(self event sym = 307) or: ((512 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
rightBracket

	^ self event sym = 93! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:14'!
rightCtrl

	^(self event sym = 305) or: ((128 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:18'!
rightMeta

	^(self event sym = 309) or: ((2048 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:03'!
rightParenthesis

	^ self event sym = 41! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:12'!
rightShift

	^(self event sym = 303) or: ((2 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/20/2012 00:24'!
rightSuper

	^ self event sym = 312! !

!SDLKeyboardAnnouncement methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/19/2012 04:27'!
scancode
	^ self event scancode! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/20/2012 00:22'!
scrollLock

	^ self event sym = 302! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:05'!
semicolon

	^ self event sym = 59! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:05'!
slash

	^ self event sym = 47! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:09'!
space

	^ self event sym = 32! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:25'!
sysReq

	^ self event sym = 317! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:08'!
tab

	^ self event sym = 9! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
underscore

	^ self event sym = 95! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:26'!
undo

	^ self event sym = 322! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:10'!
up

	^ self event sym = 273! !

SDLAnnouncement subclass: #SDLMouseAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLMouseAnnouncement commentStamp: '<historical>' prior: 0!
One of my subclasess raised when user do something with a mouse.
!

SDLMouseAnnouncement subclass: #MouseDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!MouseDown commentStamp: '<historical>' prior: 0!
I am raised when user press mouse button!

SDLMouseAnnouncement subclass: #MouseMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!MouseMove commentStamp: '<historical>' prior: 0!
I am raised when user move mouse!

!MouseMove methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 03:04'!
delta

	^ event xrel @ event yrel.! !

!MouseMove methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 03:03'!
deltaX

	^ event xrel.! !

!MouseMove methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 03:03'!
deltaY

	^ event yrel.! !

SDLMouseAnnouncement subclass: #MouseUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!MouseUp commentStamp: '<historical>' prior: 0!
I am raised when user release mouse button!

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
leftButtonPressed
	^(1 bitAnd: event state) = 1
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
middleButtonPressed
	^(2 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
rightButtonPressed
	^(4 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
wheelDownButtonPressed
	^(16 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
wheelUpButtonPressed
	^(8 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 01:02'!
x
	^ event x.! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
x1ButtonPressed
	^(32 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
x2ButtonPressed
	^(64 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 01:02'!
xy
	^ event x @ event y.! !

!SDLMouseAnnouncement methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 01:02'!
y
	^ event y.! !

TestCase subclass: #EvasTest
	instanceVariableNames: 'egg evas stage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Tests-Evas'!

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 00:37'!
addRectangle: aRectangle
	|rect|
	rect := EvasRectangle new.
	rect x: aRectangle origin x; y: aRectangle origin y; width: aRectangle width; height: aRectangle height; color: Color random.
	stage add: rect.
	^rect.
	
! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 22:57'!
createEgg
	egg := Egg new.
	evas := egg evas.
	stage := egg stage.
	egg run.
! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 23:32'!
setUp

	self createEgg.! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 18:58'!
shutdownEgg
	egg finalize.! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 23:32'!
tearDown

	self shutdownEgg.! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 23:32'!
testRect1
	| rect top |
	rect := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	top := evas topAt: 50 @ 50.
	self assert: top = rect.
! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 23:47'!
testRect2
	| rect top |
	rect := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	top := evas topAt: 500 @ 500.
	self assert: top = nil.! !

Object subclass: #Egg
	instanceVariableNames: 'evas process session announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Core'!

Egg class
	instanceVariableNames: 'eggs'!

Egg class
	instanceVariableNames: 'eggs'!

!Egg class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/8/2012 02:48'!
add: newEgg
	eggs ifNil: [eggs := Set new].
	eggs add: newEgg.! !

!Egg class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/8/2012 02:52'!
all

	^eggs! !

!Egg class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/8/2012 02:48'!
removeAll
	eggs do: [:each | each finalize].
	eggs := Set new.! !

!Egg methodsFor: 'events' stamp: 'EgorScorik 3/19/2012 02:22'!
announce: anEvent
	anEvent ifNotNil: [ self announcer announce: anEvent ]! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 3/2/2012 00:49'!
announcer
	^ announcer! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 3/2/2012 00:49'!
announcer: anObject
	announcer := anObject! !

!Egg methodsFor: 'events' stamp: 'EgorScorik 4/8/2012 02:45'!
announcerReset

	self announcer: Announcer new.! !

!Egg methodsFor: 'initialization' stamp: 'EgorScorik 1/14/2012 03:04'!
checkSession
	session == NativeBoost uniqueSessionObject
		ifFalse: [ 
			self initialize.
			session := NativeBoost uniqueSessionObject ]! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 1/2/2012 04:55'!
evas
	^ evas! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 2/11/2012 22:22'!
evas: anObject
	evas := anObject! !

!Egg methodsFor: 'initialization' stamp: 'EgorScorik 5/8/2012 02:59'!
finalize
	self stop.
	self evas finalize.
	self announcer: nil.! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 1/2/2012 04:05'!
fps
	^60! !

!Egg methodsFor: 'events' stamp: 'EgorScorik 4/8/2012 03:09'!
handleEvents
	| event  |
	event := SDLEvent new.
	SDL pumpEvents.
	[(SDL pollEvent: event) == 1] whileTrue: [
		self announce: (SDLEvent announcementFrom: event).
	].! !

!Egg methodsFor: 'initialization' stamp: 'EgorScorik 5/7/2012 16:58'!
initialize
	self evas
		ifNil: [ 
			self evas: Evas new.	"TODO move setting to somewhere"
			self evas renderMethod: 'gl_sdl'.
			self evas width: 1024 height: 768.
			self evas viewpoint: (Rectangle origin: 0 @ 0 extent: 1024 @ 768).
			self evas fullscreen: true ]
		ifNotNil: [ 
			self evas initialize.
			self evas recreate ].
	announcer ifNil: [ announcer := Announcer new ].
	SDL enableUnicode.! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 4/29/2012 04:15'!
mainLoop
	| ms msForDelay |
	ms := Time millisecondClockValue.
	self checkSession.
	self handleEvents.
	self evas render.
	ms := Time millisecondClockValue - ms.
	msForDelay := self millisecondsPerFrame - ms.
	msForDelay > 0
		ifTrue: [ (Delay forMilliseconds: msForDelay) wait ]! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 1/2/2012 04:05'!
millisecondsPerFrame
	^ (1000 / self fps) asFloat.! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 1/2/2012 04:11'!
process
	^ process! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 1/2/2012 04:11'!
process: anObject
	process := anObject! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 3/19/2012 00:05'!
run
	self stop.
	process := [
		[ [ self mainLoop ] repeat ] ifError: [ self process debug ]
	] fork! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 2/11/2012 22:22'!
session
	^ session! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 2/11/2012 22:22'!
session: anObject
	session := anObject! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 00:18'!
stage

	^ evas stage.! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 1/5/2012 22:13'!
stop
	self process ifNotNil: [ self process terminate ]! !

Object subclass: #Evas
	instanceVariableNames: 'stage handler renderMethod viewpoint width height fullscreen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!Evas commentStamp: '<historical>' prior: 0!
Instance Variables
	fullscreen:		<Boolean>
	handler:		<NBEvas>
	height:		<Integer>
	renderMethod:		<String>
	stage:		<EvasGroup>
	viewpoint:		<Rectangle>
	width:		<Integer>

fullscreen
	- xxxxx

handler
	- xxxxx

height
	- xxxxx

renderMethod
	- xxxxx

stage
	- xxxxx

viewpoint
	- xxxxx

width
	- xxxxx
!

!Evas methodsFor: 'initialize-release' stamp: 'EgorScorik 2/11/2012 22:54'!
finalize
	self handler free.
	NBEvas shutdown.
	super finalize.! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:04'!
fullscreen
	^ fullscreen! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 03:12'!
fullscreen: anObject
	fullscreen := anObject.
	self updateEngineInfo.! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/11/2012 01:35'!
handler
	^ handler! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/11/2012 01:35'!
handler: anObject
	handler := anObject! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:04'!
height
	^ height! !

!Evas methodsFor: 'initialize-release' stamp: 'EgorScorik 4/8/2012 00:28'!
initialize
	super initialize.
	NBEvas init.
	self handler: NBEvas new.
	stage ifNil: [ stage := EvasGroup forEvas: self ]! !

!Evas methodsFor: 'initialize-release' stamp: 'EgorScorik 4/8/2012 01:01'!
recreate
	self update.
	stage updateHandlers.! !

!Evas methodsFor: 'rendering' stamp: 'EgorScorik 2/12/2012 14:45'!
render
	self handler render! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:04'!
renderMethod
	^ renderMethod! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:32'!
renderMethod: aMethodName
	renderMethod := aMethodName.
	self updateRenderMethod.! !

!Evas methodsFor: 'rendering' stamp: 'EgorScorik 2/11/2012 22:47'!
renderMethods
	| list result |
	list := self handler renderMethodList.
	result := list asStringArray.
	self handler freeRenderMethodList: list.
	^result.! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 00:19'!
stage
	^ stage! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 00:19'!
stage: anObject
	^ stage := anObject! !

!Evas methodsFor: 'finding' stamp: 'EgorScorik 5/6/2012 23:50'!
topAt: aPoint
	| h |
	h := handler topAtX: aPoint x Y: aPoint y.
	^stage deeplyDetect: [:each | each handler = h ]
! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 2/12/2012 14:46'!
update
	self updateRenderMethod.
	self updateSize.
	self updateViewpoint.
	self updateEngineInfo.! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 5/7/2012 16:59'!
updateEngineInfo
	| pointer info |
	pointer := self handler getEngineInfo.
	pointer isNull
		ifTrue: [ ^ nil ].
	info := NBEvasEngineInfoSDL fromPointer: pointer.
	self fullscreen
		ifTrue: [ info fullscreen: 1 ]
		ifFalse: [ info fullscreen: 0 ].
	self handler setEngineInfo: pointer! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 2/12/2012 01:33'!
updateRenderMethod
	| methodId |
	self renderMethod ifNil: [ self error: 'Wrong render method.' ].
	methodId := self handler renderMethodLookup: self renderMethod.
	methodId > 0
		ifTrue: [ self handler setOutputMethod: methodId ]! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 2/12/2012 19:43'!
updateSize
	(self width isNil or: self height isNil)
		ifTrue: [ ^ nil ].
	self handler ifNotNil: [ self handler outputWidth: self width height: self height ]! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 2/12/2012 01:45'!
updateViewpoint
	self handler
		ifNotNil: [ 
			self viewpoint
				ifNotNil: [ 
					self handler
						viewportX: self viewpoint origin x
						y: self viewpoint origin y
						width: self viewpoint width
						height: self viewpoint height ] ]! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:04'!
viewpoint
	^ viewpoint! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:24'!
viewpoint: anObject
	viewpoint := anObject.
	self updateViewpoint.! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:04'!
width
	^ width! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:22'!
width: w height: h

	width := w.
	height := h.
	self updateSize.! !

Object variableSubclass: #ListWrapper
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Core'!

ListWrapper variableSubclass: #EvasGroup
	instanceVariableNames: 'visible evas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasGroup class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 4/8/2012 00:31'!
forEvas: anEvas
	| me |
	me := self new.
	me evas: anEvas.
	^me.
! !

!EvasGroup class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 4/7/2012 21:19'!
from: anArray
! !

!EvasGroup methodsFor: 'changing' stamp: 'EgorScorik 4/8/2012 02:34'!
addObjectToStage: anEvasObject
	anEvasObject group ifNotNil: [ anEvasObject group remove: anEvasObject ].
	anEvasObject group: self.
	anEvasObject updateHandler: evas.! !

!EvasGroup methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 00:28'!
evas
	^ evas! !

!EvasGroup methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 00:28'!
evas: anObject
	evas := anObject! !

!EvasGroup methodsFor: 'changing' stamp: 'EgorScorik 4/8/2012 02:40'!
onAdd: anEvasObject
	self addObjectToStage: anEvasObject.
! !

!EvasGroup methodsFor: 'changing' stamp: 'EgorScorik 4/8/2012 02:40'!
onRemove: anEvasObject
	self removeObjectFromStage: anEvasObject.
! !

!EvasGroup methodsFor: 'changing' stamp: 'EgorScorik 4/9/2012 01:09'!
orderChanged: anObject
! !

!EvasGroup methodsFor: 'changing' stamp: 'EgorScorik 4/8/2012 02:31'!
removeObjectFromStage: anEvasObject
	anEvasObject free.
	anEvasObject group: nil.
! !

!EvasGroup methodsFor: 'update' stamp: 'EgorScorik 4/8/2012 01:00'!
updateHandlers

	self do: [:each | each updateHandler: evas ]! !

!EvasGroup methodsFor: 'accessing' stamp: 'EgorScorik 4/7/2012 22:39'!
visible
	^ visible! !

!EvasGroup methodsFor: 'accessing' stamp: 'EgorScorik 4/7/2012 22:41'!
visible: anObject
	visible := anObject.
	self do: [:each | each visible: visible].! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 01:55'!
add: aLinkOrObject

	list add: aLinkOrObject.
	self onAdd: aLinkOrObject.! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 01:56'!
add: link after: otherLinkOrObject

	list add: link after: otherLinkOrObject.
	self onAdd: link.! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 01:48'!
add: aLinkOrObject afterLink: otherLink

	list add:aLinkOrObject afterLink: otherLink.
	self onAdd: aLinkOrObject.! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 01:57'!
add: link before: otherLinkOrObject

	list add: link before: otherLinkOrObject.
	self onAdd: link.! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 01:49'!
add: aLinkOrObject beforeLink: otherLink

	list add: aLinkOrObject beforeLink: otherLink.
	self onAdd: aLinkOrObject.! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 01:44'!
add: newObject withOccurrences: anInteger

	self shouldNotImplement.! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 02:16'!
addAll: aCollection
	list addAll: aCollection.
	aCollection do: [ :each | self onAdd: each ]! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 01:52'!
addFirst: aLinkOrObject 

	list addFirst: aLinkOrObject.
	self onAdd: aLinkOrObject.! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 02:17'!
addIfNotPresent: anObject
	(list includes: anObject)
		ifFalse: [ 
			list add: anObject.
			self onAdd: anObject ]! !

!ListWrapper methodsFor: 'adding' stamp: 'EgorScorik 4/8/2012 01:54'!
addLast: aLinkOrObject

	list addLast: aLinkOrObject.
	self onAdd: aLinkOrObject.! !

!ListWrapper methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 22:24'!
at: index put: anEvasObject
	| result |
	self onRemove: (list at: index).
	result := list at: index putLink: anEvasObject.
	self onAdd: anEvasObject.
	self orderChanged: anEvasObject.
	^ result! !

!ListWrapper methodsFor: 'enumerating' stamp: 'EgorScorik 5/3/2012 03:21'!
deepDo: aBlock
	list
		do: [ :each | 
			(each isKindOf: EvasGroup)
				ifTrue: [ each deepDo: aBlock ]
				ifFalse: [ aBlock value: each ] ]! !

!ListWrapper methodsFor: 'enumerating' stamp: 'EgorScorik 5/3/2012 12:44'!
deeplyDetect: aBlock
	self deepDo: [:each | 
		(aBlock value: each) ifTrue: [^ each]].
	^nil! !

!ListWrapper methodsFor: 'enumerating' stamp: 'EgorScorik 4/8/2012 20:48'!
deeplySelect: aBlock
	| aStream each |
	aStream := WriteStream on: LinkedList new.
	1 to: list size do: [ :index | 
		each := list at: index.
		(each isKindOf: EvasGroup)
			ifTrue: [ aStream nextPutAll: (each deeplySelect: aBlock) ]
			ifFalse: [ 
				(aBlock value: each)
					ifTrue: [ aStream nextPut: (self at: index) ] ] ].
	^ aStream contents! !

!ListWrapper methodsFor: 'dnu' stamp: 'EgorScorik 4/8/2012 02:28'!
doesNotUnderstand: aMessage

	^aMessage sendTo: list.! !

!ListWrapper methodsFor: 'initialize-release' stamp: 'EgorScorik 4/8/2012 02:33'!
initialize 

	super initialize.
	list := LinkedList new.! !

!ListWrapper methodsFor: 'changing' stamp: 'EgorScorik 4/8/2012 01:48'!
onAdd: anObject

	self subclassResponsibility! !

!ListWrapper methodsFor: 'changing' stamp: 'EgorScorik 4/8/2012 02:07'!
onRemove: anObject

	self subclassResponsibility! !

!ListWrapper methodsFor: 'changing' stamp: 'EgorScorik 4/8/2012 22:30'!
orderChanged: anObject

	self subclassResponsibility! !

!ListWrapper methodsFor: 'removing' stamp: 'EgorScorik 4/8/2012 02:19'!
remove: oldObject
	self remove: oldObject.
	self onRemove: oldObject! !

!ListWrapper methodsFor: 'removing' stamp: 'EgorScorik 4/8/2012 02:07'!
remove: aLinkOrObject ifAbsent: aBlock 
	
	list remove: aLinkOrObject ifAbsent: [^aBlock value].
	self onRemove: aLinkOrObject.! !

!ListWrapper methodsFor: 'removing' stamp: 'EgorScorik 4/8/2012 02:11'!
removeAll
	list do: [ :each | self onRemove: each ].
	list removeAll! !

!ListWrapper methodsFor: 'removing' stamp: 'EgorScorik 4/8/2012 02:22'!
removeAllFoundIn: aCollection
	aCollection
		do: [ :each | 
			(list includes: each)
				ifTrue: [ 
					list remove: each.
					self onRemove: each ] ]! !

!ListWrapper methodsFor: 'removing' stamp: 'EgorScorik 4/8/2012 02:23'!
removeAllSuchThat: aBlock
	list copy
		do: [ :each | 
			(aBlock value: each)
				ifTrue: [ 
					list remove: each.
					self onRemove: each ] ]! !

!ListWrapper methodsFor: 'removing' stamp: 'EgorScorik 4/8/2012 02:11'!
removeFirst
	self onRemove: list first.
	list removeFirst! !

!ListWrapper methodsFor: 'removing' stamp: 'EgorScorik 4/8/2012 02:12'!
removeLast
	self onRemove: list last
	list removeLast! !

!ListWrapper methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 22:30'!
swap: ix1 with: ix2
	list swap: ix1 with: ix2.
	self orderChanged: (list at: ix1).
	self orderChanged: (list at: ix2)! !

Object subclass: #SDL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDL commentStamp: '<historical>' prior: 0!
I am wrapper for libsdl (http://www.libsdl.org/)!

!SDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/19/2012 04:35'!
enableUnicode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int SDL_EnableUNICODE (1))! !

!SDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:59'!
nbLibraryNameOrHandle
	^ '/usr/lib/i386-linux-gnu/libSDL.so'! !

!SDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/19/2012 00:22'!
pollEvent: aEvent
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int SDL_PollEvent (#SDLEvent aEvent))! !

!SDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 2/26/2012 20:09'!
pumpEvents
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void SDL_PumpEvents ())! !
SDLConstants initialize!
